# ApplicationFramework
TKLCAF
TDataStd

# TDataStd_ByteArray Class Reference

An array of Byte (unsigned char) values.
.

`#include <TDataStd_ByteArray.hxx>`

Inheritance diagram for TDataStd_ByteArray:

[legend]

## Public Member Functions

Standard_EXPORT void | Init (const Standard_Integer lower, const Standard_Integer upper)
| Initialize the inner array with bounds from <lower> to <upper> .
Standard_EXPORT void | SetValue (const Standard_Integer index, const Standard_Byte value)
| Sets the <index>th element of the array to <value> .
Standard_EXPORT Standard_Byte | Value (const Standard_Integer Index) const
| Return the value of the <index>th element of the array. .
Standard_Byte | operator() (const Standard_Integer Index) const
Standard_EXPORT Standard_Integer | Lower () const
| Returns the lower boundary of the array. .
Standard_EXPORT Standard_Integer | Upper () const
| Returns the upper boundary of the array. .
Standard_EXPORT Standard_Integer | Length () const
| Returns the number of elements in the array. .
const Handle_TDataStd_HArray1OfByte | InternalArray () const
Standard_EXPORT void | ChangeArray (const Handle(TDataStd_HArray1OfByte)&newArray, const Standard_Boolean isCheckItems=Standard_True)
| Sets the inner array <myvalue> of the attribute to <newarray>. If value of <newarray> differs from <myvalue>, Backup performed and myValue refers to new instance of HArray1OfInteger that holds <newarray> values. If <ischeckitems> equal True each item of <newarray> will be checked with each item of <myvalue> for coincidence (to avoid backup). .
Standard_Boolean | GetDelta () const
void | SetDelta (const Standard_Boolean isDelta)
| for internal use only!
Standard_EXPORT | TDataStd_ByteArray ()
Standard_EXPORT const Standard_GUID & | ID () const
| Returns the ID of the attribute. .
Standard_EXPORT void | Restore (const Handle(TDF_Attribute)&with)
| Restores the backuped contents from <anattribute> into this one. It is used when aborting a transaction. .
Standard_EXPORT Handle_TDF_Attribute | NewEmpty () const
| Returns an new empty attribute from the good end type. It is used by the copy algorithm. .
Standard_EXPORT void | Paste (const Handle(TDF_Attribute)&into, const Handle(TDF_RelocationTable)&RT) const

This method is different from the "Copy" one,
because it is used when copying an attribute from
a source structure into a target structure. This
method may paste the contents of <me> into
<intoattribute>.
The given pasted attribute can be full or empty of
its contents. But don't make a NEW! Just set the
contents!
It is possible to use <arelocationtable> to
get/set the relocation value of a source
attribute.
.

virtual Standard_EXPORT Standard_OStream & | Dump (Standard_OStream &OS) const
| Dumps the minimum information about <me> on <astream>. .
virtual Standard_EXPORT Handle_TDF_DeltaOnModification | DeltaOnModification (const Handle(TDF_Attribute)&anOldAttribute) const
| Makes a DeltaOnModification between <me> and <anoldattribute>. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT const Standard_GUID & | GetID ()
| Static methods ============== //! Returns an ID for array. .
static Standard_EXPORT Handle_TDataStd_ByteArray | Set (const TDF_Label &label, const Standard_Integer lower, const Standard_Integer upper, const Standard_Boolean isDelta=Standard_False)
| Finds or creates an attribute with the array. If <isdelta> == False, DefaultDeltaOnModification is used. If attribute is already set, all input parameters are refused and the found attribute is returned. .

## Private Member Functions

void | RemoveArray ()

## Private Attributes

Handle_TDataStd_HArray1OfByte | myValue
Standard_Boolean | myIsDelta

## Constructor & Destructor Documentation

Standard_EXPORT TDataStd_ByteArray::TDataStd_ByteArray | ( |  | ) |

## Member Function Documentation

Standard_EXPORT void TDataStd_ByteArray::ChangeArray | ( | const Handle(TDataStd_HArray1OfByte)& | newArray,
|  | const Standard_Boolean | isCheckItems = `Standard_True`
| ) |

virtual Standard_EXPORT Handle_TDF_DeltaOnModification TDataStd_ByteArray::DeltaOnModification | ( | const Handle(TDF_Attribute)& | anOldAttribute | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_OStream& TDataStd_ByteArray::Dump | ( | Standard_OStream & | OS | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

Standard_Boolean TDataStd_ByteArray::GetDelta | ( |  | ) | const`[inline]`

static Standard_EXPORT const Standard_GUID& TDataStd_ByteArray::GetID | ( |  | ) | `[static]`

Standard_EXPORT const TDataStd_ByteArray::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from TDF_Attribute.

Standard_EXPORT const Standard_GUID& TDataStd_ByteArray::ID | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TDataStd_ByteArray::Init | ( | const Standard_Integer | lower,
|  | const Standard_Integer | upper
| ) |

const Handle_TDataStd_HArray1OfByte TDataStd_ByteArray::InternalArray | ( |  | ) | const

Standard_EXPORT Standard_Integer TDataStd_ByteArray::Length | ( |  | ) | const

Standard_EXPORT Standard_Integer TDataStd_ByteArray::Lower | ( |  | ) | const

Standard_EXPORT Handle_TDF_Attribute TDataStd_ByteArray::NewEmpty | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_Byte TDataStd_ByteArray::operator() | ( | const Standard_Integer | Index | ) | const`[inline]`

Standard_EXPORT void TDataStd_ByteArray::Paste | ( | const Handle(TDF_Attribute)& | into,
|  | const Handle(TDF_RelocationTable)& | RT
| ) | const`[virtual]`

| Implements TDF_Attribute.

void TDataStd_ByteArray::RemoveArray | ( |  | ) | `[inline, private]`

Standard_EXPORT void TDataStd_ByteArray::Restore | ( | const Handle(TDF_Attribute)& | with | ) | `[virtual]`

| Implements TDF_Attribute.

static Standard_EXPORT Handle_TDataStd_ByteArray TDataStd_ByteArray::Set | ( | const TDF_Label & | label,
|  | const Standard_Integer | lower,
|  | const Standard_Integer | upper,
|  | const Standard_Boolean | isDelta = `Standard_False`
| ) | `[static]`

void TDataStd_ByteArray::SetDelta | ( | const Standard_Boolean | isDelta | ) | `[inline]`

Standard_EXPORT void TDataStd_ByteArray::SetValue | ( | const Standard_Integer | index,
|  | const Standard_Byte | value
| ) |

Standard_EXPORT Standard_Integer TDataStd_ByteArray::Upper | ( |  | ) | const

Standard_EXPORT Standard_Byte TDataStd_ByteArray::Value | ( | const Standard_Integer | Index | ) | const

## Field Documentation

Standard_Boolean TDataStd_ByteArray::myIsDelta `[private]`

Handle_TDataStd_HArray1OfByte TDataStd_ByteArray::myValue `[private]`

The documentation for this class was generated from the following files:

- TDataStd_ByteArray.hxx
- TDataStd_ByteArray.lxx